/*  9h3  9h4  9t3 10h3 11h3 11h5 12h3 12h4 12h5 12d3 13h3 13h5 14h3 14h4 15h4 
 * 15h5 15h6 16h3 16h4 16h6 16d4 17h4 17h5 18h4 18h5 19h4 20h8 22h5 22h6 23h4 
 * 23h5 24d4 24h5 24h10 24t4 26h10 28d8 */
int NN=16,N1=4,N2=0;
/* ================== 2D-Gitter nach Betts =========================== */
/* => Betts-Notation example: 14h4 => N=14,N1=1,N2=4 => 1 helix, dy=4 */

  /*  i=site 0..NN, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  /* besser site(i,dx,dy[,dz])  ??? */
  int site_move(int i,int d,int s){ 
    if(i<0 || i>=NN)return -1;while(s<0)s+=NN/N1;
    if(d==0)return (i+s)%(NN/N1)+(i/(NN/N1))*(NN/N1);   /* x-direction */
    if(d==1)return (i+s+((i/(NN/N1)+s)/N1)*(N2-N1+NN/N1))%(NN/N1)+
                   ((i/(NN/N1)+s)%N1)*(NN/N1);          /* y-direction */
    return -1;}

  int main(int argc,char *argv[]){
    int i,j; 
    if(argc==4){
      sscanf(argv[1],"%d",&NN);
      sscanf(argv[2],"%d",&N1);
      sscanf(argv[3],"%d",&N2);}
    printf("NN=%d N1=%d N2=%d\n",NN,N1,N2);  
    printf("Gitter:\n");for(i=0;i<20 /* NN/N1 */;i++){ for(j=0;j<24 /* NN/N1 */;j++)
     printf(" %2d",site_move(site_move(0,1,i),0,j));printf("\n");}
    return 0;}    
